$purple: #542266;
$border-size: 0.15mm;
$font-serif: RobotoSlab;
$font-sans: Roboto;
$font-mono: RobotoMono;

$size-factor: 1;
$fluid-factor: 1;
$base-font-size: 9;
$golden_ratio: 1.618;

@function font-size-factor($factor) {
  @return $size_factor * $base_font_size * $factor + 0pt;
}

@function line-height-factor($factor) {
  @return $size_factor * $base_font_size * $factor * $golden_ratio *
    $fluid_factor + 0pt;
}

$paragraph-font-family: $font-sans;
$paragraph-font-size: font-size-factor(1);
$paragraph-line-height: line-height-factor(1);

$h1-font-family: $font-sans;
$h1-font-size: font-size-factor(1.7);
$h1-line-height: line-height-factor(1.7);
$h1-font-weight: 800;
$h1-color: $purple;

$h2-font-family: $font-sans;
$h2-font-size: font-size-factor(1.5);
$h2-line-height: line-height-factor(1.5);
$h2-font-weight: 500;
$h2-color: $purple;

$h3-font-family: $font-sans;
$h3-font-size: font-size-factor(1.35);
$h3-line-height: line-height-factor(1.35);
$h3-font-weight: 500;
$h3-color: $purple;

$h4-font-family: $font-sans;
$h4-font-size: font-size-factor(1.2);
$h4-line-height: line-height-factor(1.2);
$h4-font-weight: 500;
$h4-color: $purple;

$h5-font-family: $font-sans;
$h5-font-size: font-size-factor(1.1);
$h5-line-height: line-height-factor(1.1);
$h5-font-weight: 500;
$h5-color: $purple;

$h6-font-family: $font-sans;
$h6-font-size: font-size-factor(1);
$h6-line-height: line-height-factor(1);
$h6-font-weight: 500;
$h6-color: $purple;

$code-font-family: $font-mono;
$code-font-size: font-size-factor(1);

// Style

body {
  font-family: $font-serif;
  counter-reset: chapter section subsection subsubsection paragraph subparagraph
    figure;
  padding: 0;
  margin: 0;
}

// Paragraph

p {
  font-family: $paragraph-font-family;
  font-size: $paragraph-font-size;
  line-height: $paragraph-line-height;
  text-align: justify;
}

// images

figure {
  img {
    max-width: 100%;
  }
}

figcaption {
  font-family: $paragraph-font-family;
  font-size: $paragraph-font-size;
  line-height: $paragraph-line-height;
  text-align: center;
}

.figcaptionid:before {
  counter-increment: figure;
  content: counter(chapter) "." counter(figure);
}

.figureref:after {
  content: target-counter(attr(href url), chapter) "."
    target-counter(attr(href url), figure);
}

// list

ul {
  font-family: $paragraph-font-family;
  font-size: $paragraph-font-size;
  font-family: $paragraph-font-family;
  line-height: $paragraph-line-height;
}

// Links

a {
  text-decoration: none;
  color: black;
}

// Headers

h1 {
  font-family: $h1-font-family;
  font-size: $h1-font-size;
  line-height: $h1-line-height;
  color: $h1-color;
  font-weight: $h1-font-weight;
  counter-reset: section;
}

h1:before {
  counter-increment: chapter;
  content: counter(chapter);
  margin-right: 5mm;
}

h1 code {
  font-size: $h1-font-size;
}

h2 {
  font-family: $h2-font-family;
  font-size: $h2-font-size;
  line-height: $h2-line-height;
  color: $h2-color;
  font-weight: $h2-font-weight;
  counter-reset: subsection;
}

h2 code {
  font-size: $h2-font-size;
}

h2:before {
  counter-increment: section;
  content: counter(chapter) "." counter(section);
  margin-right: 5mm;
}

h3 {
  font-family: $h3-font-family;
  font-size: $h3-font-size;
  line-height: $h3-line-height;
  color: $h3-color;
  font-weight: $h3-font-weight;
  counter-reset: subsubsection;
}

h3:before {
  counter-increment: subsection;
  content: counter(chapter) "." counter(section) "." counter(subsection);
  margin-right: 5mm;
}

h3 code {
  font-size: $h3-font-size;
}

h4 {
  font-family: $h4-font-family;
  font-size: $h4-font-size;
  line-height: $h4-line-height;
  color: $h4-color;
  font-weight: $h4-font-weight;
  counter-reset: paragraph;
}

h4:before {
  counter-increment: subsubsection;
  content: counter(chapter) "." counter(section) "." counter(subsection) "."
    counter(subsubsection);
  margin-right: 5mm;
}

h4 code {
  font-size: $h4-font-size;
}

h5 {
  font-family: $h5-font-family;
  font-size: $h5-font-size;
  line-height: $h5-line-height;
  color: $h5-color;
  font-weight: $h5-font-weight;
  counter-reset: subparagraph;
}

h5:before {
  counter-increment: paragraph;
  content: counter(chapter) "." counter(section) "." counter(subsection) "."
    counter(subsubsection) "." counter(paragraph);
  margin-right: 5mm;
}

h5 code {
  font-size: $h5-font-size;
}

h6 {
  font-family: $h6-font-family;
  font-size: $h6-font-size;
  line-height: $h6-line-height;
  color: $h6-color;
  font-weight: $h6-font-weight;
}

h6:before {
  counter-increment: subparagraph;
  content: counter(chapter) "." counter(section) "." counter(subsection) "."
    counter(subsubsection) "." counter(paragraph) "." counter(subparagraph);
  margin-right: 5mm;
}

h6 code {
  font-size: $h6-font-size;
}

// Code

pre {
  font-family: $code-font-family;
  border: $border-size solid black;
  font-size: $code-font-size;
  padding: 2mm;

  code {
    background: transparent;
  }
}

code {
  font-family: $code-font-family;
  font-size: $code-font-size;
  background: #efefef;
}

// ref / pageref / label

.ref:after {
  content: target-counter(attr(href url), chapter) "."
    target-counter(attr(href url), section) "."
    target-counter(attr(href url), subsection);
}

.pageref:after {
  content: target-counter(attr(href url), page);
}

//

.summary {
  counter-reset: summary_chapter summary_section summary_subsection;

  h1::before {
    counter-increment: none;
    content: "";
    margin: 0;
  }

  ul {
    list-style-type: none;
    padding: 0;
    margin: 0;
  }

  li {
    width: 100%;
    font-size: $paragraph-font-size;
    line-height: $paragraph-line-height;
    font-family: $font-sans;
    color: black;
  }

  ul {
    padding: 0;
    overflow: hidden;
    list-style: none;
  }

  ul span:first-child {
    padding-right: 0.33em;
    background: white;
  }

  ul a {
    text-decoration: none;
    color: black;
  }

  ul ul {
    counter-reset: summary_section;
  }

  li > ul {
    margin-left: 8mm;
  }

  // level 1

  ul li {
    margin-bottom: 3mm;
    font-weight: 800;
  }

  ul li:before {
    float: left;
    width: 0;
    white-space: nowrap;
    content: "";
  }

  ul a:before {
    width: 5mm;
    display: inline-block;
    padding-right: 3mm;
    background: white;
    counter-increment: summary_chapter;
    content: counter(summary_chapter);
  }

  // level 2

  ul ul li {
    font-weight: 400;
    margin-bottom: 0;
  }

  ul ul li:before {
    float: left;
    width: 0;
    white-space: nowrap;
    content: ". . . . . . . . . . . . . . . . . . . . "
      ". . . . . . . . . . . . . . . . . . . . "
      ". . . . . . . . . . . . . . . . . . . . "
      ". . . . . . . . . . . . . . . . . . . . "
      ". . . . . . . . . . . . . . . . . . . . "
      ". . . . . . . . . . . . . . . . . . . . "
      ". . . . . . . . . . . . . . . . . . . . "
      ". . . . . . . . . . . . . . . . . . . . "
      ". . . . . . . . . . . . . . . . . . . . "
      ". . . . . . . . . . . . . . . . . . . . "
      ". . . . . . . . . . . . . . . . . . . . "
      ". . . . . . . . . . . . . . . . . . . . ";
  }

  ul ul a:before {
    content: counter(summary_section);
    counter-increment: summary_section;
    content: counter(summary_chapter) "." counter(summary_section);
  }

  // level 3

  ul ul ul {
  }

  ul ul ul a:before {
    counter-increment: summary_subsection;
    content: counter(summary_chapter) "." counter(summary_section) "."
      counter(summary_subsection);
  }

  ul a:after {
    float: right;
    content: target-counter(attr(href url), page);
    background: white;
    padding-left: 0.33em;
  }
}

// Header

@page {
  size: A4;
  margin: 2cm 1cm;
  padding: 0;

  @top-left {
    content: "";
    height: 1cm;
    width: 6cm;
    text-align: left;
    font-size: $paragraph-font-size;
    font-family: $paragraph-font-family;
  }
  @top-right {
    content: "";
    height: 1cm;
    width: 6cm;
    text-align: right;
    font-size: $paragraph-font-size;
    font-family: $paragraph-font-family;
  }
  @top-center {
    content: "";
    display: block;
    border-bottom: $border-size solid black;
    width: 100%;
  }
  @bottom-left {
    content: "";
    height: 1cm;
    width: 6cm;
    text-align: left;
    font-size: $paragraph-font-size;
    font-family: $paragraph-font-family;
  }
  @bottom-right {
    content: counter(page);
    height: 1cm;
    width: 6cm;
    text-align: right;
    font-size: $paragraph-font-size;
    font-family: $paragraph-font-family;
  }
  @bottom-center {
    content: "";
    display: block;
    border-top: $border-size solid black;
    width: 100%;
  }
}

// table

table {
  font-family: $font-sans;
  font-size: $paragraph-font-size;
  width: 100%;
  border-collapse: collapse;
}

table,
th,
td {
  border: $border-size solid black;
}

th,
td {
  padding: 1mm;
}

th {
  background: black;
  color: white;
  font-weight: 800;
}

// specific

header {
  .document-head {
    display: flex;
    align-items: center;
    justify-content: space-between;
    border-top: $border-size solid black;
    border-bottom: $border-size solid black;
    padding: 5mm 0;
    font-family: $font-sans;

    .document-head-text {
      text-align: right;
    }

    .document-head-type-initials,
    .document-head-type {
      font-weight: 800;
    }

    img {
      height: 1cm;
    }
  }

  .document-title {
    border-bottom: $border-size solid black;
    padding: 5mm 0;
    font-family: $font-sans;
    text-align: right;
  }
}
